﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using CycleTileDataSample.Resources;

namespace CycleTileDataSample
{
    public partial class MainPage : PhoneApplicationPage
    {
        private List<string> tileList;

        // Constructor
        public MainPage()
        {
            InitializeComponent();

            if (tileList == null)
            {
                tileList = new List<string>();
                tileList.Add("/Assets/Tiles/windowsphonetile1.png");
                tileList.Add("/Assets/Tiles/windowsphonetile2.png");
                tileList.Add("/Assets/Tiles/windowsphonetile3.png");
                tileList.Add("/Assets/Tiles/windowsphonetile4.png");
                tileList.Add("/Assets/Tiles/windowsphonetile5.png");
                tileList.Add("/Assets/Tiles/windowsphonetile6.png");
                tileList.Add("/Assets/Tiles/windowsphonetile7.png");
                tileList.Add("/Assets/Tiles/windowsphonetile8.png");
                tileList.Add("/Assets/Tiles/windowsphonetile9.png");
            }

            // Sample code to localize the ApplicationBar
            //BuildLocalizedApplicationBar();
        }

        private void CreateCycleTile()
        {
            List<Uri> imageList = new List<Uri>();

            foreach (string imagePath in tileList)
            {
                Uri uri = new Uri(imagePath, UriKind.Relative);
                imageList.Add(uri);
            }

            CycleTileData cycleTileData = new CycleTileData();
            cycleTileData.Title = "New CycleTileData";
            cycleTileData.Count = imageList.Count;
            cycleTileData.CycleImages = imageList;

            ShellTile.Create(new Uri("/MainPage.xaml", UriKind.Relative), cycleTileData, false);
        }

        private void UpdateCycleTile(ShellTile cycleTile)
        {
            List<Uri> imageList = new List<Uri>();

            foreach (string imagePath in tileList)
            {
                Uri uri = new Uri(imagePath, UriKind.Relative);
                imageList.Add(uri);
            }

            CycleTileData cycleTileData = new CycleTileData();
            cycleTileData.Title = "Updated CycleTileData";
            cycleTileData.Count = imageList.Count;
            cycleTileData.CycleImages = imageList;

            cycleTile.Update(cycleTileData);
        }

        private void Button_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            ShellTile cycleTile = ShellTile.ActiveTiles.FirstOrDefault(o => o.NavigationUri.ToString().Contains("/MainPage.xaml"));
            if (cycleTile == null)
            {
                CreateCycleTile();
            }
            else
            {
                UpdateCycleTile(cycleTile);
            }
        }

        // Sample code for building a localized ApplicationBar
        //private void BuildLocalizedApplicationBar()
        //{
        //    // Set the page's ApplicationBar to a new instance of ApplicationBar.
        //    ApplicationBar = new ApplicationBar();

        //    // Create a new button and set the text value to the localized string from AppResources.
        //    ApplicationBarIconButton appBarButton = new ApplicationBarIconButton(new Uri("/Assets/AppBar/appbar.add.rest.png", UriKind.Relative));
        //    appBarButton.Text = AppResources.AppBarButtonText;
        //    ApplicationBar.Buttons.Add(appBarButton);

        //    // Create a new menu item with the localized string from AppResources.
        //    ApplicationBarMenuItem appBarMenuItem = new ApplicationBarMenuItem(AppResources.AppBarMenuItemText);
        //    ApplicationBar.MenuItems.Add(appBarMenuItem);
        //}
    }
}